-- Just write the code here now. It will execute every time the game loads.

-- Loader --
local frame = CreateFrame("FRAME", "TPOLoader");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
local function eventHandler(self, event, ...)
    index = GetMacroIndexByName("TPO")
    if index > 0 then EditMacro(index, "TPO", "Ability_Garrison_OrangeBird", "/click TPO_Button")
    else CreateMacro("TPO", "Ability_Garrison_OrangeBird", "/click TPO")
    end
end
frame:SetScript("OnEvent", eventHandler);

local frame = CreateFrame("Button", "TPO_Button", nil, "SecureActionButtonTemplate")
frame:SetAttribute("type", "macro")
frame:SetAttribute("macrotext", "/target Trader Yula\n/target Elder Surehide\n/target Pyxni Pennypocket\n/target Tradesman Portanuus\n/target Tai'tasi\n/target Krixel Pinchwhistle\n/target Talgaiir the Ironrender\n/target Ribchewer\n/tpo check\n/cleartarget")

ahcut = ahcut or 1
dotdSource = dotdSource or "DBMarket"
longTermSource = longTermSource or "DBHistorical"
verbose = false
IDlist = {109136,109118,109124,109125,109126,109127,109128,109129,109131,109132,109133,109134,109135,109119,109137,109138,109139,109140,109141,109142,109143,109144,109693,110609,111557}
bestTraders={"Krixel Pinchwhistle (N)",
             "Trader Yula (A) / Elder Surehide (H)",
             "Pyxni Pennypocket (N)",
             "Pyxni Pennypocket (N)",
             "Pyxni Pennypocket (N)",
             "Pyxni Pennypocket (N)",
             "Pyxni Pennypocket (N)",
             "Pyxni Pennypocket (N)",
             "Krixel Pinchwhistle (N)",
             "Krixel Pinchwhistle (N)",
             "Krixel Pinchwhistle (N)",
             "Krixel Pinchwhistle (N)",
             "Krixel Pinchwhistle (N)",
             "Trader Yula (A) / Elder Surehide (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Pyxni Pennypocket (N)",
             "Talgaiir the Ironrender (A) / Ribchewer (H)",
             "Trader Yula (A) / Elder Surehide (H)"}

function comparePerTrader(a,b)
    return a[2] > b[2]
end
function compareAllTraders(a,b)
    return a[4] > b[4]
end

-- SLASH Command --
SLASH_TRADINGPOSTOPTIMISER1, SLASH_TRADINGPOSTOPTIMISER2 = '/tpo', '/tradingpostoptimiser'
function SlashCmdList.TRADINGPOSTOPTIMISER(msg, editbox)
    cmd, arg = msg:match("^(%S*)%s*(.-)$")
    -- Toggle verbose --
    if msg == "verbose" then
        verbose = not verbose
        print("TPO: verbose now", verbose)
    elseif msg == "ahcut" then
        if ahcut == 1 then ahcut = .95 else ahcut = 1 end
        print("TPO: Using the Auction House cut now", ahcut==.95)
    -- Set the DotD price source --
    elseif cmd == "dotd" then
        if TSMAPI:ValidateCustomPrice(arg) then
            dotdSource = arg
            print("TPO: The Deal of the Day price source is now \""..dotdSource.."\".")
        elseif arg == "" then print("TPO: The Deal of the Day price source is currently \""..dotdSource.."\".")
        else print("TPO Error: \""..arg.."\" is not a valid price source.")
        end
    -- Set the Long Term price source --
    elseif cmd == "longterm" then
        if TSMAPI:ValidateCustomPrice(arg) then
            longTermSource = arg
            print("TPO: The best Long Term trade price source is now \""..longTermSource.."\".")
        elseif arg == "" then print("TPO: The best Long Term trade price source is currently \""..longTermSource.."\".")
        else print("TPO Error: \""..arg.."\" is not a valid price source.")
        end
    -- Reset configuration --
    elseif msg == "reset" then
        ahcut = 1
        dotdSource = "DBMarket"
        longTermSource = "DBHistorical"
        verbose = false
        print("TPO: Configuration settings reset to defaults.")
    -- Run Trading Post Optimiser --
    elseif msg == "check" then
        -- Initialise the mats --
        matsList = {}
        for i=1,25 do
            _, link = GetItemInfo(IDlist[i])
            table.insert(matsList, {link, 0, bestTraders[i], 0})
        end
        -------------------------
        valid = false
        name, realm = UnitName("target")
        print("-----------------------------------------------")
        if name == "Trader Yula" or name == "Elder Surehide" then
            print("TPO: Trader Yula (A) / Elder Surehide (H) detected.")
            resourceCost = {5,4,8,8,8,8,8,8,5,5,5,5,5,4,8,8,8,8,8,8,8,8,5,10,4}
            valid = true
        elseif name == "Pyxni Pennypocket" then
            print("TPO: Pyxni Pennypocket (N) detected.")
            resourceCost = {10,8,4,4,4,4,4,4,10,10,10,10,10,8,10,10,10,10,10,10,10,10,4,8,8}
            valid = true
        elseif name == "Tradesman Portanuus" or name == "Tai'tasi" then
            print("TPO: Tradesman Portanuus (A) / Tai'tasi (H) detected.")
            resourceCost = {6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6}
            valid = true
        elseif name == "Krixel Pinchwhistle" then
            print("TPO: Krixel Pinchwhistle (N) detected.")
            resourceCost = {4,6,10,10,10,10,10,10,4,4,4,4,4,6,5,5,5,5,5,5,5,5,8,8,10}
            valid = true
        elseif name == "Talgaiir the Ironrender" or name == "Ribchewer" then
            print("TPO: Talgaiir the Ironrender (A) / Ribchewer (H) detected.")
            resourceCost = {8,10,5,5,5,5,5,5,8,8,8,8,8,10,4,4,4,4,4,4,4,4,10,4,5}
            valid = true
        else
            for i=1,25 do
                matsList[i][4] = (TSMAPI:GetCustomPriceValue(longTermSource,TSMAPI.Item:ToItemString(IDlist[i]))*ahcut)/4
            end
            _, link = GetItemInfo(120146)
            table.insert(matsList, {link, 3000, "all Traders", 3000})
            table.sort(matsList, compareAllTraders)
            if verbose then
                for i=1,25 do
                    print(i,matsList[i][1],TSMAPI:MoneyToString(matsList[i][4],"OPT_PAD","OPT_TRIM"))
                end
            end
            print("TPO: The best long term profit trade is "..matsList[1][1].." at "..TSMAPI:MoneyToString(matsList[1][4],"OPT_PAD","OPT_TRIM").." / resource from \""..matsList[1][3].."\".")
            print("TPO Error: No traders detected. Please make sure you are in a Garrison with a Trading Post. If you are, please report your faction and the current trader to the add-on developer at http://wow.curseforge.com/addons/trading-post-optimiser/tickets/")
        end
        
        if valid then
            for i=1,25 do
                matsList[i][2] = (TSMAPI:GetCustomPriceValue(dotdSource,TSMAPI.Item:ToItemString(IDlist[i]))*ahcut)/resourceCost[i]
                matsList[i][4] = (TSMAPI:GetCustomPriceValue(longTermSource,TSMAPI.Item:ToItemString(IDlist[i]))*ahcut)/4
            end
            _, link = GetItemInfo(120146)
            table.insert(matsList, {link, 3000, "all Traders", 3000})
            table.sort(matsList, comparePerTrader)
            if verbose then
                for i=1,25 do
                    print(i,matsList[i][1],TSMAPI:MoneyToString(matsList[i][2],"OPT_PAD","OPT_TRIM"))
                end
            end
            print("TPO: The deal of the day is "..matsList[1][1].." at "..TSMAPI:MoneyToString(matsList[1][2],"OPT_PAD","OPT_TRIM").." / resource.")
            table.sort(matsList, compareAllTraders)
            if verbose then
                for i=1,25 do
                    print(i,matsList[i][1],TSMAPI:MoneyToString(matsList[i][4],"OPT_PAD","OPT_TRIM"))
                end
            end
            print("TPO: The best long term profit trade is "..matsList[1][1].." at "..TSMAPI:MoneyToString(matsList[1][4],"OPT_PAD","OPT_TRIM").." / resource from \""..matsList[1][3].."\".")
        end
    else
        print("-----------------------------------------------")
        print("Trading Post Optimiser commands:")
        print("/tpo - Shows the available commands.")
        print("/tpo dotd <priceSource> - Use a custom price source for the Deal of the Day (Current: \""..dotdSource.."\").")
        print("/tpo longterm <priceSource> - Use a custom price source for the best Long Term trade (Current: \""..longTermSource.."\").")
        print("/tpo ahcut - Toggle taking the Auction House cut (5%) into account (Current: "..tostring(ahcut==.95)..").")
        print("/tpo reset - Reset configuration settings back to defaults.")
        print("/click TPO_Button - Run Trading Post Optimiser (optionally just use the generated \"TPO\" macro).")
        print("/tpo verbose - Toggle verbose mode (Current: "..tostring(verbose)..").")
        print("-----------------------------------------------")
    end
end